using System;

namespace UsageOfUnsafe
{
	class User
	{
		unsafe public static void usePointers(int[] array)
		{
			fixed(int* ptrArray = array)
			{
				for (int i = 0; i < array.Length; i++)
					Console.Write(*(ptrArray + i) + " ");
			}
			
			Console.WriteLine();
		}

		static void Main(string[] args)
		{
			int[] anArray = {1, 2, 3, 4, 5};

			usePointers(anArray);

			ValTypeX instOfX;
			instOfX.val = 2;

			ValTypeX[] myXArray = new ValTypeX[2];
			myXArray[0] = new ValTypeX();
			myXArray[0].val = 1;

			myXArray[1] = new ValTypeX();
			myXArray[1].val = 2;

			RefTypeY objY = new RefTypeY();
			objY.val = 4;

			unsafe 
		{
			ValTypeX* ptrX = &instOfX;
			// No need to use fixed for Value type (these are on the stack, remember!)
			Console.WriteLine(ptrX->val);

			fixed(ValTypeX* ptrX2 = myXArray) 
		{
			Console.WriteLine(ptrX2->val);
		}

			fixed(int* pVal = &objY.val) 
		{
			Console.WriteLine(*pVal);
		}
		}
		}
	}
}
